var GAME = {}; //Game mechanics and parameters namespace
//constants
GAME.GROUND = "ground"; //data value assigned for ground squares (impassable areas)
GAME.PLAYER = "player"; //data value assigned to player's position
GAME.TICK_RATE = 12; //rate of PS_TICK
GAME.BG_COLOR = 0x73ACB9; //color of the playing field's background 
GAME.HTML_BG_COLOR = 0x000000; //color of the html background (area outside perlenspiel canvas)
GAME.GOAL_COLOR = 0xC2BF2E; //color of the goal square.
GAME.GROUND_COLOR = 0x714322; //color of a block

//Colors used by blocks

GAME.INACTIVE_COLOR = PS.COLOR_GRAY;
GAME.RED = PS.COLOR_RED;
GAME.GREEN = 0x5AA032;
GAME.BLUE = PS.COLOR_BLUE;
GAME.INDIGO = PS.COLOR_INDIGO;

//Colors used by powerups
GAME.LIGHT_RED = 0xFF6464;
GAME.LIGHT_GREEN = 0x64FF64;
GAME.LIGHT_BLUE = 0x6464FF;
GAME.LIGHT_INDIGO = 0xFF64FF;

//Colors used by the player
GAME.DARK_RED = 0x640000;
GAME.DARK_GREEN = 0x285020;
GAME.DARK_BLUE = 0x000064;
GAME.DARK_INDIGO = 0x640064;

//variables
	//The following array is used to contain the positions and colors of dynamic blocks altered by the player
GAME.movingBlockArray = []//parameters: [x, y, direction, color]; these are the 2D array's order of properties 
GAME.level_count = 1; //tracks what level/map we are currently on
GAME.next_level = false; //set this boolean to true when we are ready to go to the next level
GAME.reset_ready = true; //activated when reseting the game is allowed

var PLAYER = {}; //player related functions and properties

//constants:
PLAYER.COLOR = GAME.GREEN; //color of the player square; default currently set to green
PLAYER.X = 0; //player X position 
PLAYER.Y = 0; //player Y position
//variables:
PLAYER.IsJumpingUp = false; //set this boolean to true when the player wants to jump (hits UP arrow)
PLAYER.IsFallingDown = false; //set this boolean to true when gravity needs to be activated
PLAYER.airTime = 0; //tracks the ammount of time the player has spent in the air
PLAYER.dead = false; //check if the player fell too far or not
PLAYER.jumpSoundOn = false; //true if the jump sound effect should be played. False if not.

PLAYER.KEY = 0; //the key the player has just pressed
PLAYER.nextColor = 0; //color of the bead next to the player relative to key pressed (used inside PLAYER.NextSquare)
PLAYER.nextData = 0; //data of the bead next to the player relative to key pressed
PLAYER.holding_left = false; //Boolean to check if the "left" arrow is held
PLAYER.holding_right = false; //Boolean check if the "right" arrow is held
PLAYER.holding_up = false;
PLAYER.holding_down = false;

var XYLO = {}; //The PS.Xylophone function isn't working, so I'm implementing it customly here:

XYLO.XyloFiles = [
	"a4", "bb4", "b4",
	"c5", "db5", "d5", "eb5", "e5", "f5", "gb5", "g5", "ab5", "a5", "bb5", "b5",
	"c6", "db6", "d6", "eb6", "e6", "f6", "gb6", "g6", "ab6", "a6", "bb6", "b6",
	"c7", "db7", "d7", "eb7", "e7", "f7", "gb7", "g7", "ab7", "a7", "bb7", "b7"
];

XYLO.Xylophone = function ( val )
{
	"use strict";
	var fn, str;

	fn = "[PS.Xylophone] ";

	if ( typeof val !== "number" )
	{
		PS.Oops(fn + "Parameter is not a number");
		return PS.ERROR;
	}
	val = Math.floor(val);
	if ( val < 1 )
	{
		val = 1;
	}
	else if ( val > 39 )
	{
		val = 39;
	}

	str = "xylo_" + PS.XyloFiles[val - 1];
	PS.AudioPlay(str);
	return str;
};
